;*****************************************************************
; converted to PE format for relocatable text
; tunnel by rel (Modded to run on Dex4u OS by Dex)
; Assemble with fasm
;       Http://Rel.Betterwebber.com
;*****************************************************************
use32

format PE GUI 4.0
 
 ; specify entry point
 entry start
 
 ; put everything in the same section, except PE relocations
 section '.dex4u' code readable executable writeable

diameter         equ 64
diamxscale       equ 64 * diameter
scale            equ 256

start:
        mov ax,18h            ; set ax to nonlinear base
        mov ds,ax             ; add them to ds
        mov es,ax             ; and es.

 ;----------------------------------------------------;
 ; Get calltable address.                             ;
 ;----------------------------------------------------;

        mov edi,Functions     ; this is the interrupt
        mov al,0              ; we use to load the DexFunction.inc
        mov ah,0x0a           ; with the address to dex4u functions.
        int 40h

 ;----------------------------------------------------;
 ; Change to mode 13h.                                ;
 ;----------------------------------------------------;
        mov ax,0x0013         ;Dex4u realmode int, set to mode 13h
        call [RealModeInt10h]
        mov edi,0xA0000       ;Dex4u point to screen
;*****************************************************************
;*****************************************************************
;*****************************************************************
   fninit

;====set palette
        mov   dx, 03c8h                  ;palette write register
        out   dx, al                     ;send value
        inc   dx                         ;0x3c9(write RGB values)
        mov cx, 256                      ;whole 256 colors
   fldpi                                 ;st0 = pi
   mov [ishort], 180                     ;st0 = 180, st1 = pi
   fild [ishort]
   palloop:
        mov bx, 256
        sub bx, cx
        shl bx,1

        mov [ishort], bx
        fild [ishort]                    ;st0 = deg, st1 = 180, st2 = pi
        fmul st0, st2
        fdiv st0, st1
        fsin                             ;st0 = sin(rad)
        mov [ishort], 64
        fimul [ishort]
        fistp [ishort]

        mov ax, [ishort]
        out  dx, al                     ;red
        shl al,1                        ;blue

        out  dx, al
        shr al, 2
        out  dx, al                     ;than green

   loop palloop                         ;go back if not 0
        fstp st0
        fstp st0
        push  es
        mov   ax,8h                     ;set up lin selector
        mov   es,ax
MainLoop:
        mov [scx],160
        mov [scy],100

        inc [frame]

        ;displacement
        fild [frame]
        mov [ishort], 50
        fidiv [ishort]
        fsin
        mov [ishort], 120
        fimul [ishort]
        fistp [ishort]
        mov ax, [ishort]
        add [scx], ax
        fild [frame]
        mov [ishort], 60
        fidiv [ishort]
        fsin
        mov [ishort], 80
        fimul [ishort]
        fistp [ishort]
        mov ax, [ishort]
        add [scy], ax

        ;===========tunnel
        mov dx,200
        mov edi, 0
        add   edi,0xA0000
      tunnel_yloop:
        mov cx,320
      tunnel_xloop:

        ;atan2
        fldpi                                   ;st0 = pi
        mov ax, [scy]
        mov [short_var], ax
        sub [short_var], dx
        fild [short_var]                        ;st0 = dy, st1 = pi

        mov ax, [scx]
        mov [short_var], ax
        sub [short_var], cx
        fild [short_var]                        ;st0 = dx, st1 = dy, st2 = pi

        fpatan                                  ;st0 = atan(dy/dx) = atan(st1/st0)

        mov [short_var], scale
        fimul [short_var]                       ;atan(st0))*256/pi
        fdiv st0, st1
        fistp [short_var]                       ;short_var = scaledpi
        jmp @f
tunnel_xloop1:                                  ;NOTE: got a loop our of range error (Dex4u only), so did this temp.
        jmp tunnel_xloop
@@:
        mov ax, [scx]
        sub ax, cx                              ;cmx
        mov [ishort], ax
        fild [ishort]                           ;st0 = cmx
        fmul st0, st0                           ;cmx * cmx
        mov ax, [scy]
        sub ax, dx
        mov [ishort], ax
        fild [ishort]                           ;st0 = cmy st1 = cmx*cmx
        fmul st0, st0                           ;cmy * cmy
        fadd st0, st1                           ;st0 cmx^2 + cmy^2
        fsqrt                                   ;sqrt st0
        mov [ishort], diamxscale                ;st0 = diamxscale st1 = sqrt(dist)
        fild [ishort]
        fdiv st0, st1
        fistp [ishort]
        fstp st0
        fstp st0
        fstp st0
        mov ax, [ishort]
        mov bx, [short_var]
        add ax, [frame]
        add bx, [frame]
        xor ax, bx
        mov byte[es:edi], al

        inc edi
        loop  tunnel_xloop1
        dec dx
        jnz tunnel_yloop

        call [KeyPressedNoWait]
        cmp ax,1
        jne MainLoop                            ;Dex4u no keypress then loop

        ;textmode
        pop   es
        call  [SetDex4uFonts]                   ;Dex4u set text mode
        ret                                     ;Dex4u return contol to CLI


frame     dw  0
ishort    dw  0
short_var dw  0
scx       dw  0
scy       dw  0

 ; Trick: used to trim the executable size
 db "--$$EXE+CUT+HERE$$-",0

 include 'Dex.inc'                      ;Dex4u function call table

 ; make sure PE relocations are emitted
 section '.reloc' data discardable fixups
