;
; Demo loader for Dex4u reloc executables
; by 0x4e71
;


SIZE_OF_DEX_HDR = 16
OFFSET_TO_IMAGE = 8
OFFSET_TO_ENTRY = 12

use32
        ORG   0x200000          ; where our program is loaded to
        jmp   start             ; jump to the start of program.
        db    'DEX1'            ; We check for this, to make shore it a valid Dex4u file.

start:
        mov   ax,18h            ; set ax to nonlinear base
        mov   ds,ax             ; add them to ds
        mov   es,ax             ; and es.

        mov   edi,Functions     ; this is the interrupt
        mov   al,0              ; we use to load the DexFunction.inc
        mov   ah,0x0a           ; with the address to dex4u functions.
        int   40h 
      
        ; get filename
        call  [GetParams]
        cld
        mov ecx,2
.l1:    lodsb
        test al,al
        jz .nofile
        cmp al,' '
        jnz .l1
        loop .l1

.l3:    lodsb       
        test al,al
        jz .nofile
        cmp al,' '
        jz .l3        
        dec esi
        
        ; load file       
        mov edi,Functions+4096
        call [FloppyfileLoad]
        jc .nofile
        
        ; parse header
        mov edi,Functions+4096        
        mov eax,[edi+OFFSET_TO_IMAGE]  ; get offset to image
        cmp eax,SIZE_OF_DEX_HDR
        jz  .noreloc
        lea esi,[edi+SIZE_OF_DEX_HDR] ; start of relocs
        xor ecx,ecx
        lea edx,[edi+eax] ; start of image

.relloop:       
        lodsd                ; load 32 bit base offset
        cmp eax,0xFFFFFFFF   ; end?
        jz .donereloc      
        mov ebx,eax          ; ebx = base offset
        lodsw                ; get number of byte entries
        mov ecx,eax          ; load loop counter
.r:     xor eax,eax          ; clear eax
        lodsb                ; get byte entry 
        add ebx,eax          ; add to offset
        mov eax,[edx+ebx]    ; get dword to patch in binary image 
        add eax,edx          ; add program address to it
        mov [edx+ebx],eax    ; store it back
        loop .r              ; repeat for all byte entries
        jmp .relloop         ; repeat until end of relocations
.donereloc:       
.noreloc: 
        add edx, [edi+OFFSET_TO_ENTRY]   ; offset to entry point
        jmp edx

.nofile: mov esi,err_nofile
         call [PrintString]
         call [WaitForKeyPress]
         ret

err_nofile: db 'Cannot open file (or no file specified)',0

include 'Dex.inc'      ; Here is where we includ our "DexFunctions.inc" file